<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class KeepInChat extends \Google\Protobuf\Internal\Message
{
    


    protected $keepType = null;
    


    protected $serverTimestamp = null;
    


    protected $key = null;
    


    protected $deviceJid = null;
    


    protected $clientTimestampMs = null;
    


    protected $serverTimestampMs = null;

    













    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getKeepType()
    {
        return isset($this->keepType) ? $this->keepType : 0;
    }

    public function hasKeepType()
    {
        return isset($this->keepType);
    }

    public function clearKeepType()
    {
        unset($this->keepType);
    }

    




    public function setKeepType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\KeepType::class);
        $this->keepType = $var;

        return $this;
    }

    



    public function getServerTimestamp()
    {
        return isset($this->serverTimestamp) ? $this->serverTimestamp : 0;
    }

    public function hasServerTimestamp()
    {
        return isset($this->serverTimestamp);
    }

    public function clearServerTimestamp()
    {
        unset($this->serverTimestamp);
    }

    




    public function setServerTimestamp($var)
    {
        GPBUtil::checkInt64($var);
        $this->serverTimestamp = $var;

        return $this;
    }

    



    public function getKey()
    {
        return $this->key;
    }

    public function hasKey()
    {
        return isset($this->key);
    }

    public function clearKey()
    {
        unset($this->key);
    }

    




    public function setKey($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\MessageKey::class);
        $this->key = $var;

        return $this;
    }

    



    public function getDeviceJid()
    {
        return isset($this->deviceJid) ? $this->deviceJid : '';
    }

    public function hasDeviceJid()
    {
        return isset($this->deviceJid);
    }

    public function clearDeviceJid()
    {
        unset($this->deviceJid);
    }

    




    public function setDeviceJid($var)
    {
        GPBUtil::checkString($var, True);
        $this->deviceJid = $var;

        return $this;
    }

    



    public function getClientTimestampMs()
    {
        return isset($this->clientTimestampMs) ? $this->clientTimestampMs : 0;
    }

    public function hasClientTimestampMs()
    {
        return isset($this->clientTimestampMs);
    }

    public function clearClientTimestampMs()
    {
        unset($this->clientTimestampMs);
    }

    




    public function setClientTimestampMs($var)
    {
        GPBUtil::checkInt64($var);
        $this->clientTimestampMs = $var;

        return $this;
    }

    



    public function getServerTimestampMs()
    {
        return isset($this->serverTimestampMs) ? $this->serverTimestampMs : 0;
    }

    public function hasServerTimestampMs()
    {
        return isset($this->serverTimestampMs);
    }

    public function clearServerTimestampMs()
    {
        unset($this->serverTimestampMs);
    }

    




    public function setServerTimestampMs($var)
    {
        GPBUtil::checkInt64($var);
        $this->serverTimestampMs = $var;

        return $this;
    }

}

